#include <ogcsys.h>
#include <stdio.h>
#include <string.h>
#include "sound.h"

unsigned long cur_play=0;
int wavout_enable=0;
short sound_buf[MAX_SOUND_BANKLEN*4*2] __attribute__ ((__aligned__ (32)));

//48000,chan:2Œ
static void wavout_callback()
{
	if (!wavout_enable) {
		return;
	}
	
	int sound_buf_len = 4096;
	DCFlushRange(&sound_buf[cur_play/2], PGA_SAMPLES);
	AUDIO_InitDMA((u32) &sound_buf[cur_play/2], PGA_SAMPLES);
	AUDIO_StartDMA();
	
	cur_play += PGA_SAMPLES;
	if (cur_play>=sound_buf_len*4)
		cur_play = 0;
}

void wavoutClear()
{
	memset(sound_buf, 0, sizeof(sound_buf));
}

int wavoutInit()
{
	wavout_enable=0;
	wavoutClear();
	
	AUDIO_Init(NULL);
	AUDIO_SetDSPSampleRate(AI_SAMPLERATE_48KHZ);
	AUDIO_RegisterDMACallback (wavout_callback);
	return 0;
}

void wavoutStart()
{
	wavout_enable = 1;
	wavout_callback();
}

void wavoutStop()
{
	wavout_enable = 0;
	wavoutClear();
	AUDIO_StopDMA();
}
